<?php
/*

 $Id: ip.php,v 1.27 2004/06/25 03:02:53 philips Exp $
 $Source: /tmp/maintain/docs/ip.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!

	@header Ip Document
	This tool will allow users to edit/change the IP's for use in their zone.
*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
        if (!check_session()) { logout(); }
	
	setup_user_environment($action, $zone_id);

/* End House Keeping */

// $host_id is passed in via form or url data
$host = new Host($host_id);
$ip = new IP($ip_int);

// process any submits that may come our way
if ($host->id) { 
	$title = "Update IP Information";
}
else {
	$title = "View IP Information";
}
show_template('header');


?> <font class="header1"><?= $title ?></font> <?

/*!
	@function select_random_ip
	@discussion Finds the next ip address in specified range and updates specified host with the new ip
	@param $zone_range	The ID of the range we are looking at
	@param $host_id		The ID of the host we are working on.
*/
if ( $action == 'select_random_ip' ) {

	if (!$user->has_access($host->zone->id)) {
		$conf['ui']->show_access_denied();
		exit();
	}
	
	// get an un-used IP from the range passed
	$range = new Range($zone_range);
	$free_ip = $range->get_free_ip();

	// check the hardware address in this new location
	if ($host->ha != '000000000000') {
		$host->check_hardware_address($host->ha,$host->id,$range->id,$free_ip->subnet->id);
	}
		
	// make sure they have access to the host and then update it
	if (!$conf['error']->error_state) {
		$host->update_ip($free_ip->ip_int);
	
		//now display the confirmation...
		$conf['ui']->display_confirmation("$host->name's IP address has been Updated","",$conf['web_path'] . "/host.php?action=show_host&amp;host_id=$host_id");
	} 
	// Bad Kittiy No snackie	
	else { 
		$conf['ui']->display_confirmation("$host->name's IP change encountered an error",$conf['error']->get_message('ha'),$conf['web_path'] . "/host.php?action=show_host&host_id=$host_id");	
	}
}

/*!
	@function select_ip
	@dicussion if they want to pick a specific ip address
*/
elseif ( $action == 'select_ip' ) {

	if (!$user->has_access($host->zone->id)) { 
		$conf['ui']->show_access_denied();
		exit();
	}

	if ($ip_int) {

		//Check the hardware address in the new IP range
		if ($host->ha !== '000000000000') {
			$ip = new IP($ip_int);
			$host->check_hardware_address($host->ha,$host->id,0,$ip->subnet->id);
		}

		if (!$conf['error']->error_state) {
		        //ok were good update the host
		        $host->update_ip($ip_int);
			$conf['ui']->display_confirmation("$host->name's IP address has been Updated","",$conf['web_path'] . "/host.php?action=show_host&host_id=$host_id");
		}
		else {
			$conf['ui']->display_confirmation("$host->name encountered errors",$conf['error']->get_message('ha'),$conf['web_path'] . "/host.php?action=show_host&host_id=$host_id");
		}

	} //non static if...

	// this is going to be a dynamic IP ... set it as such
	elseif ( $range_id ) {

		// first check to make sure we aren't going to overlap HA's
		if ($host->ha != '000000000000') {
			$host->check_hardware_address($host->ha,$host->id,$range_id);
		}

		//we do this so it sets ip_id to 0 
		if (!$conf['error']->error_state) {
		   	$host->update_ip(0,$range_id);
			$conf['ui']->display_confirmation("$host->name's IP address has been Updated","",$conf['web_path'] . "/host.php?action=show_host&amp;host_id=$host_id");
		} 
		else { 
			$conf['ui']->display_confirmation("$host->name's IP change encountered errors",$conf['error']->get_message('ha'),$conf['web_path'] . "/host.php?action=show_host&host_id=$host_id");
		}
		
		$range = new Range($range_id);

	} // End if this is a dynamic range we are setting it to. 

} //if select_ip

/*!
	@function add_ip_block
	@discussion If we are trying to add a IP Block. This can only be done by Admins
*/
elseif ($action == "add_ip_block" AND $user->is_admin ) {

	/* Convert from dotted quad to int */
	$start_int = IP::ip2int($start_block);
	$end_int   = IP::ip2int($end_block);

	//If it's true we've found a ip block that's already there
	// find_ip_block returns the ID of an existing block that matches
	if (IPBlock::find_ip_block($start_int,$end_int,$name)) {
		$conf['error']->add_error('name',"Duplicate IP Block Already Found");
	} //check for duplicate ip block

	// Check to make sure it's in dotted quad format
	if (!IP::is_dotted_quad($start_block) OR !$ip->is_dotted_quad($end_block) ) {
		$conf['error']->add_error('start',"Invalid IP Address");
	}

	// Check to make sure start < end 
	if ($start_int >= $end_int) {		
		$conf['error']->add_error('start',"Start Address is greater or equal to End Address");
	} //if start >= end

	//If no errors
	if (!$conf['error']->error_state) {

		//Create the new ip_block
		$block = new IPBlock(0,$start_int,$end_int,$name,$enabled);

		$conf['ui']->display_confirmation("IP Block Created","The Ip block $name ($start_block --> $end_block) has been created", $conf['web_path'] . "/admin.php");

	} //no errors!

	//Errors doh return to show
	else {
		$action = "show_add_ip";
	}

} //add_ip_block

/*!
	@function delete_ip_block
	@discussion Delete a ip block, it checks to make sure
		    you don't try to kill any children first
*/
elseif ($action == "delete_ip_block" AND $user->is_admin) { 

	$block = new IPBlock($block_id);

	$child = new Child("ip_block",0,0,$block);

	if ($child->has_children) { 
		echo "<p align=\"center\" class=\"fatalerror\">Fatal Error Block has Children</p>";
	}
	else {
		$block->delete();
		$conf['ui']->display_confirmation("IP Block Deleted","The IP Block has been removed from Maintain", $conf['web_path'] . "/admin.php");
	}

} // delete_ip_block

/*!
	@function update_ip_block_enabled
	@discussion enable/disable the ipblock
*/
elseif ($action == "update_ip_block_enabled" AND $user->is_admin) { 
	
	$block = new IPBlock($block_id);
	$block->set_enabled($enabled);
	$action = "show_ip_blocks";

} // update_ip_block_enabled

/*!
	@function update_ip_block
	@discussion does the actual update on the ip block, must be admin
*/
elseif ($action == "update_ip_block" AND $user->is_admin) {

	if (!IP::is_dotted_quad($start)) {
		$conf['error']->add_error('start',"Invalid IP Address");
	}
	if (!IP::is_dotted_quad($end)) { 
		$conf['error']->add_error('end',"Invalid IP Address");
	}

	if (!$conf['error']->error_state) { 

		$start_int = IP::ip2int($start); //Convert user input to int form
		$end_int = IP::ip2int($end);

		$block = new IPBlock($block_id); 

		// Set all of the values
		$block->set_enabled($enabled);
		$block->set_start($start_int);
		$block->set_end($end_int);
		$block->set_name($name);

		$name = $block->get_name(); // to return to user

		$conf['ui']->display_confirmation("Update Compleate", "$name updated succesfully", $conf['web_path'] . "/ip.php?action=show_ip_blocks");
	} 

	else { 
		$action = "show_edit_ipblock";
	}

} // update_ip_block


/*
##########################
end of the action if block
##########################

##########################

##########################
start of the display if block
##########################
*/

// seams kinda random...
if ( $host_id and $action != "select_ip" and $action != "select_random_ip") {
	print "<p>You are updating the IP address for $host->hostname.</p>\n";
}

/*!
	@function edit
	@discussion edit a host and it's relevent ip address
*/
if ( $action == 'edit' ) {
	// show the current host information and then give a listing of IP's
	$conf['ui']->show_ip_ranges($host, $host->zone->ip_ranges());
} // edit

/*!
	@function show_edit_ipblock
	@discussion If we want to edit a ipblock and they are a ADMIN
*/
elseif ($action == 'show_edit_ipblock' AND $user->is_admin) { 
	$block = new IPBlock($block_id);

	require ($conf['prefix'] . "/templates/show_ip_block.inc");

} // show_edit_range

/*!
	@function show_add_ip
	@discussion If we want to add a ipblock and they are a ADMIN
*/
elseif ( $action == 'show_add_ip' AND $user->is_admin ) { 

	require ($conf['prefix'] . "/templates/show_add_ip.inc");

} //show_add_ip

/*!
	@function show_ip_blocks
	@discussion displays the ipblocks
*/
elseif ($action == "show_ip_blocks" AND $user->is_admin ) { 

	$ip_blocks = IPBlock::get_all_ip_blocks();

	require ($conf['prefix'] . "/templates/show_ip_blocks.inc");

} // show_ip_blocks

/*!
	@function confirm_delete_ip_blocks
	@discussion shows a box asking for a confirmation that 
		    you want to delete a ip block
*/
elseif ($action == "confirm_delete_ip_block") { 

	$block = new IPBlock($block_id);
	$child = new Child("ip_block",0,0,$block);
	$block_start = IP::int2ip($block->get_start());
	$block_end   = IP::int2ip($block->get_end());

	if ($child->has_children) {
		echo "<p class=\"fatalerror\" align=\"center\">Fatal Error This IP Block still has Child Objects</p>";
		$child->show_children();
	}
	else { 
		$name = $block->get_name();
		$start = IP::int2ip($block->get_start());
		$end = IP::int2ip($block->get_end());
		$conf['ui']->show_confirm($conf['web_path'] . "/ip.php?action=delete_ip_block&amp;block_id=$block_id", "Are you sure you want to delete $name ($start - $end)");
	}

} // confirm_delete_ip_block



/*!
	@function show_ranges
	@discussion display a number of ranges, uses $user-&gt;view
*/
elseif ( $action == 'show_ranges' ) {
	
	// just show a list of the currently available IP's
	if ( ! $user->view ) {
		$user->view = new View();
	}

	if ( $sort_type ) {
		$user->view->initialize($sort_type, $sort_offset);
	}
	else {
		$user->view->initialize('range', 0);
	}

	$ranges = $conf['zone']->ip_ranges($user->view);
	$conf['ui']->show_ip_ranges($host, $ranges);
} // show_ranges

/*!
	@function show_available_ips
	@discussion this only gets called when we have a range & host_id passed in
*/
elseif ( $action == 'show_available_ips' ) {

	$range = new Range($zone_range);

	$ips = $range->get_free_addresses();

	$conf['ui']->show_ips($host, $ips);
} // show_available_ips

show_template('footer'); 

?>
